/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010 France Telecom R&D
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: GreeterJMSImpl.java 21400 2011-06-08 21:05:31Z jppouzol $
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.cxf.transport.reliablejms.example.springmdp;

import org.apache.cxf.jms_greeter.JMSGreeterPortType;
import org.apache.cxf.jms_greeter.MyFault;

@javax.jws.WebService(portName = "GreeterPort", serviceName = "JMSGreeterService", targetNamespace = "http://cxf.apache.org/jms_greeter", endpointInterface = "org.apache.cxf.jms_greeter.JMSGreeterPortType")
public class GreeterJMSImpl implements JMSGreeterPortType {

    protected void waitALittle() {
        System.out.print("Waiting 5 seconds: ");
        for (int i = 1; i <= 5; i++) {
            System.out.print(i + "...");
            try {
                Thread.sleep(1000l);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        System.out.println("  done !");

    }

    public String greetMe(String me) throws MyFault {
        System.out.println("Executing operation greetMe");
        System.out.println("Message received: " + me);


        waitALittle();

        if ("checked".equals(me)) {
            throw new MyFault("checked exception");
        } else if ("unchecked".equals(me)) {
            throw new IllegalArgumentException("unchecked exception");
        }

        return "Hello " + me;
    }

    public void greetMeOneWay(String me) {
        System.out.println("Executing operation greetMeOneWay");
        System.out.println("Message received: " + me);

        waitALittle();
        
        if ("unchecked".equals(me)) {
            throw new IllegalArgumentException("unchecked exception");
        }
    }

    public String sayHi(String requestType) {
        System.out.println("Executing operation sayHi");
        System.out.println("Message received: " + requestType);

        waitALittle();

        return "Hi " + requestType;
    }

}
